Package: alabaster.sce
Title: Load and Save SingleCellExperiment from File
Version: 1.10.0
Date: 2024-10-16
Authors@R: person("Aaron", "Lun", role=c("aut", "cre"), email="infinite.monkeys.with.keyboards@gmail.com")
License: MIT + file LICENSE
Description: 
    Save SingleCellExperiment into file artifacts, and load them back into memory.
    This is a more portable alternative to serialization of such objects into RDS files.
    Each artifact is associated with metadata for further interpretation;
    downstream applications can enrich this metadata with context-specific properties.
Depends: SingleCellExperiment, alabaster.base
Imports: methods, alabaster.se, jsonlite
Suggests: knitr, testthat, BiocStyle, rmarkdown
VignetteBuilder: knitr
RoxygenNote: 7.2.3
biocViews: DataImport, DataRepresentation
git_url: https://git.bioconductor.org/packages/alabaster.sce
git_branch: RELEASE_3_22
git_last_commit: a6eed09
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: no
Packaged: 2025-10-30 02:28:44 UTC; biocbuild
Author: Aaron Lun [aut, cre]
Maintainer: Aaron Lun <infinite.monkeys.with.keyboards@gmail.com>

.onLoad <- function(libname, pkgname) {
    registerReadObjectFunction("single_cell_experiment", readSingleCellExperiment)
}

.onUnload <- function(libname, pkgname) {
    registerReadObjectFunction("single_cell_experiment", NULL)
}

#' Read a SingleCellExperiment from disk
#'
#' Read a \linkS4class{SingleCellExperiment} object from its on-disk representation.
#' This is usually not directly called by users, but is instead called by dispatch in \code{\link{readObject}}.
#'
#' @param path String containing a path to a directory, itself created using the \code{\link{saveObject}} method for \linkS4class{SingleCellExperiment} objects.
#' @param metadata Named list of metadata for this object, see \code{\link{readObjectFile}} for details.
#' @param ... Further arguments passed to \code{\link{readRangedSummarizedExperiment}} and internal \code{\link{altReadObject}} calls.
#' 
#' @return A \linkS4class{SingleCellExperiment} object.
#'
#' @author Aaron Lun
#'
#' @seealso
#' \code{"\link{saveObject,SingleCellExperiment-method}"}, to save the SingleCellExperiment to disk.
#'
#' @examples
#' # Mocking up an SCE:
#' mat <- matrix(rpois(10000, 10), ncol=10)
#' colnames(mat) <- letters[1:10]
#' rownames(mat) <- sprintf("GENE_%i", seq_len(nrow(mat)))
#'
#' se <- SingleCellExperiment(list(counts=mat))
#' se$stuff <- LETTERS[1:10]
#' se$blah <- runif(10)
#' reducedDims(se) <- list(
#'     PCA=matrix(rnorm(ncol(se)*10), ncol=10),
#'     TSNE=matrix(rnorm(ncol(se)*2), ncol=2)
#' )
#' altExps(se) <- list(spikes=SummarizedExperiment(list(counts=mat[1:2,])))
#'
#' # Staging it: 
#' tmp <- tempfile()
#' saveObject(se, tmp)
#' readObject(tmp)
#'
#' @export
#' @aliases loadSingleCellExperiment
#' @importFrom alabaster.se readRangedSummarizedExperiment loadSummarizedExperiment
#' @import SingleCellExperiment alabaster.base 
#' @importFrom jsonlite fromJSON
readSingleCellExperiment <- function(path, metadata, ...) {
    se <- readRangedSummarizedExperiment(path, metadata, ...) # see comments in readRangedSummarizedExperiment in alabaster.se.
    se <- as(se, "SingleCellExperiment")

    rddir <- file.path(path, "reduced_dimensions")
    if (file.exists(rddir)) {
        reddim.names <- fromJSON(file.path(rddir, "names.json"))
        all.reddims <- vector("list", length(reddim.names))
        for (y in seq_along(reddim.names)) {
            all.reddims[[y]] <- altReadObject(file.path(rddir, y - 1L), ...)
        }
        names(all.reddims) <- reddim.names
        reducedDims(se, withDimnames=FALSE) <- all.reddims
    }

    aedir <- file.path(path, "alternative_experiments")
    if (file.exists(aedir)) {
        altexp.names <- fromJSON(file.path(aedir, "names.json"))
        all.altexps <- vector("list", length(altexp.names))
        for (y in seq_along(altexp.names)) {
            all.altexps[[y]] <- altReadObject(file.path(aedir, y - 1L), ...)
        }
        names(all.altexps) <- altexp.names 
        altExps(se, withDimnames=FALSE) <- all.altexps
    }

    info <- metadata$single_cell_experiment
    main.nm <- info$main_experiment_name
    if (!is.null(main.nm)) {
        mainExpName(se) <- main.nm
    }

    se
}

##################################
######### OLD STUFF HERE #########
##################################

#' @export
loadSingleCellExperiment <- function(exp.info, project, ...) {
    se <- loadSummarizedExperiment(exp.info, project, ...)
    se <- as(se, "SingleCellExperiment")

    all.reds <- exp.info$single_cell_experiment$reduced_dimensions
    if (length(all.reds)) {
        red.names <- character(length(all.reds))
        for (i in seq_along(all.reds)) {
            red.info <- all.reds[[i]]
            red.exp.info <- acquireMetadata(project, path=red.info$resource$path)
            all.reds[[i]] <- .loadObject(red.exp.info, project=project)
            red.names[i] <- red.info$name
        }
        names(all.reds) <- red.names
        reducedDims(se) <- all.reds
    }

    all.alts <- exp.info$single_cell_experiment$alternative_experiments
    if (length(all.alts)) {
        alt.names <- character(length(all.alts))
        for (i in seq_along(all.alts)) {
            alt.info <- all.alts[[i]]
            alt.exp.info <- acquireMetadata(project, path=alt.info$resource$path)
            all.alts[[i]] <- .loadObject(alt.exp.info, project=project)
            alt.names[i] <- alt.info$name
        }
        names(all.alts) <- alt.names
        altExps(se) <- all.alts
    }

    main.nm <- exp.info$single_cell_experiment$main_experiment_name
    if (!is.null(main.nm)) {
        mainExpName(se) <- main.nm
    }

    se
}

# This tests the stageObject generic for SCE's.
# library(testthat); library(alabaster.sce); source("test-SingleCellExperiment.R")

# Making an SE and annotating it.
mat <- matrix(rpois(2000, 10), ncol=10)
colnames(mat) <- paste0("SAMPLE_", seq_len(ncol(mat)))

se <- SingleCellExperiment(list(counts=mat, cpm=mat/10))
se$stuff <- LETTERS[1:10]
se$blah <- runif(10)
rowData(se)$whee <- runif(nrow(se))
rownames(se) <- sprintf("GENE_%i", seq_len(nrow(se)))

test_that("stageObject works as expected for SCE objects", {
    tmp <- tempfile()
    dir.create(tmp)

    info <- stageObject(se, tmp, "rnaseq")
    alabaster.base::.writeMetadata(info, tmp)

    expect_identical(vapply(info$summarized_experiment$assays, function(x) x$name, ""), assayNames(se))
    cdf <- read.csv(file.path(tmp, info$summarized_experiment$column_data$resource$path), row.names=1)
    expect_equal(cdf, as.data.frame(colData(se)))
    expect_identical(info$single_cell_experiment, setNames(list(), character(0)))

    # Round trip works.
    out <- loadSingleCellExperiment(info, tmp)
    expect_s4_class(out, "SingleCellExperiment")
    expect_equal(rowData(out), rowData(se))
    expect_equal(colData(out), colData(se))

    # New world works.
    tmp <- tempfile()
    saveObject(se, tmp)
    out2 <- readObject(tmp)
    expect_s4_class(out2, "SingleCellExperiment")
    expect_identical(rowData(out2), rowData(se))
    expect_identical(colData(out2), colData(se))
})

test_that("saveObject works with some non-trivial rowRanges", {
    all.ranges <- GRanges("chrX", IRanges(seq_len(nrow(mat) * 2), width=1))
    rowRanges(se) <- splitAsList(all.ranges, rep(seq_len(nrow(mat)), length.out=length(all.ranges)))

    tmp <- tempfile()
    saveObject(se, tmp, "rnaseq")
    out2 <- readObject(tmp)

    expect_identical(rowData(out2), rowData(se))
    expect_identical(rowRanges(out2), rowRanges(se))
    expect_identical(rownames(out2), rownames(se))
})

test_that("stageObject works as expected with reduced dims inside", {
    reducedDims(se) <- list(PCA=matrix(rnorm(ncol(mat)*50), ncol=50), TSNE=cbind(TSNE1=runif(ncol(mat)), TSNE2=runif(ncol(mat))))

    tmp <- tempfile()
    dir.create(tmp)

    info <- stageObject(se, tmp, "rnaseq")
    alabaster.base::.writeMetadata(info, tmp)

    rd.info <- info$single_cell_experiment$reduced_dimensions
    expect_identical(length(rd.info), 2L)
    expect_identical(vapply(rd.info, function(x) x$name, ""), c("PCA", "TSNE"))

    # Round trip works.
    out <- loadSingleCellExperiment(info, tmp)
    expect_identical(reducedDimNames(out), reducedDimNames(se))
    expect_identical(as.matrix(reducedDim(out, "PCA")), reducedDim(se, "PCA"))
    expect_identical(as.matrix(reducedDim(out, "TSNE")), reducedDim(se, "TSNE"))

    # New world works.
    tmp <- tempfile()
    saveObject(se, tmp)
    out2 <- readObject(tmp)
    expect_identical(reducedDimNames(out2), reducedDimNames(se))
    expect_identical(as.matrix(reducedDim(out2, "PCA")), reducedDim(se, "PCA"))
    expect_identical(as.matrix(reducedDim(out2, "TSNE")), reducedDim(se, "TSNE"))
})

test_that("stageObject fails with non-unique, non-empty reduced dim names", {
    reducedDims(se) <- list(PCA=matrix(rnorm(ncol(mat)*50), ncol=50), TSNE=cbind(TSNE1=runif(ncol(mat)), TSNE2=runif(ncol(mat))))
    colnames(int_colData(se)$reducedDims) <- c("FOO", "FOO") # need to force the issue as the setters don't normally allow duplicates.

    tmp <- tempfile()
    dir.create(tmp)
    expect_error(info <- stageObject(se, tmp, "rnaseq"), "duplicate")

    colnames(int_colData(se)$reducedDims) <- c("", "FOO") 
    unlink(file.path(tmp, "rnaseq"), recursive=TRUE)
    expect_error(info <- stageObject(se, tmp, "rnaseq"), "empty")
})

test_that("stageObject works as expected with alternative experiments inside", {
    tmp <- tempfile()
    dir.create(tmp)

    copy <- se
    altExps(se) <- list(spikes=copy[1:2,], protein=copy[3:5,])

    info <- stageObject(se, tmp, "rnaseq")
    alabaster.base::.writeMetadata(info, tmp)

    expect_identical(vapply(info$single_cell_experiment$alternative_experiments, function(x) x$name, ""), altExpNames(se))

    round <- loadSingleCellExperiment(info, tmp)
    expect_identical(altExpNames(round), altExpNames(se))
    expect_identical(rownames(altExp(round, 1)), rownames(altExp(se, 1)))
    expect_identical(rownames(altExp(round, 2)), rownames(altExp(se, 2)))

    # New world works.
    tmp <- tempfile()
    saveObject(se, tmp)
    out2 <- readObject(tmp)
    expect_identical(altExpNames(out2), altExpNames(se))
    expect_identical(rownames(altExp(out2, 1)), rownames(altExp(se, 1)))
    expect_identical(rownames(altExp(out2, 2)), rownames(altExp(se, 2)))
})

test_that("stageObject fails with non-unique, non-empty altexp names", {
    copy <- se
    altExps(se) <- list(spikes=copy[1:2,], protein=copy[3:5,])
    colnames(int_colData(se)$altExps) <- c("FOO", "FOO") # need to force the issue as the setters don't normally allow duplicates.

    tmp <- tempfile()
    dir.create(tmp)
    expect_error(info <- stageObject(se, tmp, "rnaseq"), "duplicate")

    colnames(int_colData(se)$altExps) <- c("", "FOO") 
    unlink(file.path(tmp, "rnaseq"), recursive=TRUE)
    expect_error(info <- stageObject(se, tmp, "rnaseq"), "empty")
})

test_that("stageObject works as expected when we slap in a main name", {
    tmp <- tempfile()
    dir.create(tmp)
    mainExpName(se) <- "FOO"

    info <- stageObject(se, tmp, "rnaseq")
    alabaster.base::.writeMetadata(info, tmp)

    expect_identical(info$single_cell_experiment$main_experiment_name, "FOO")

    round <- loadSingleCellExperiment(info, tmp)
    expect_identical(mainExpName(round), "FOO")

    # New world works.
    tmp2 <- tempfile()
    saveObject(se, tmp2)
    out2 <- readObject(tmp2)
    expect_identical(mainExpName(out2), "FOO")

    # Fails if there's an alternative experiment with the same name.
    altExp(se, "FOO") <- se[1:10,]
    unlink(file.path(tmp, "rnaseq"), recursive=TRUE)
    expect_error(stageObject(se, tmp, "rnaseq"), "conflicting name 'FOO'")

})

#' Save a SingleCellExperiment to disk
#'
#' Save a \linkS4class{SingleCellExperiment} to its on-disk representation.
#' 
#' @param x A \linkS4class{SingleCellExperiment} object or one of its subclasses.
#' @inheritParams alabaster.base::saveObject
#' @param ... Further arguments to pass to the RangedSummarizedExperiment method.
#'
#' @author Aaron Lun
#' 
#' @return \code{x} is saved into \code{path} and \code{NULL} is invisibly returned.
#'
#' @seealso
#' \code{\link{readSingleCellExperiment}}, to read the SingleCellExperiment back into the R session.
#' 
#' @examples
#' # Mocking up an SCE:
#' mat <- matrix(rpois(10000, 10), ncol=10)
#' colnames(mat) <- letters[1:10]
#' rownames(mat) <- sprintf("GENE_%i", seq_len(nrow(mat)))
#'
#' se <- SingleCellExperiment(list(counts=mat))
#' se$stuff <- LETTERS[1:10]
#' se$blah <- runif(10)
#' reducedDims(se) <- list(
#'     PCA=matrix(rnorm(ncol(se)*10), ncol=10),
#'     TSNE=matrix(rnorm(ncol(se)*2), ncol=2)
#' )
#' altExps(se) <- list(spikes=SummarizedExperiment(list(counts=mat[1:2,])))
#'
#' # Staging it: 
#' tmp <- tempfile()
#' saveObject(se, tmp)
#' list.files(tmp, recursive=TRUE)
#' 
#' @name saveSingleCellExperiment
#' @aliases 
#' stageObject,SingleCellExperiment-method
NULL

#' @export
#' @rdname saveSingleCellExperiment
#' @import SingleCellExperiment alabaster.base methods
#' @importFrom jsonlite toJSON
setMethod("saveObject", "SingleCellExperiment", function(x, path, ...) {
    callNextMethod() # see comments in saveObject,RangedSummarizedExperiment-method in alabaster.se.

    red.nms <- reducedDimNames(x)
    if (length(red.nms)) {
        rddir <- file.path(path, "reduced_dimensions")
        dir.create(rddir, showWarnings=FALSE)
        for (i in seq_along(red.nms)) {
            red.path <- file.path(rddir, i - 1L)
            tryCatch({
                altSaveObject(reducedDim(x, red.nms[i], withDimnames=FALSE), red.path, ...)
            }, error=function(e) {
                stop("failed to stage 'reducedDim(<", class(x)[1], ">, \"", red.nms[i], "\")'\n  - ", e$message)
            })
        }
        write(toJSON(red.nms), file=file.path(rddir, "names.json"))
    }

    alt.nms <- altExpNames(x) 
    if (length(alt.nms)) {
        aedir <- file.path(path, "alternative_experiments")
        dir.create(aedir, showWarnings=FALSE)
        for (i in seq_along(alt.nms)) {
            alt.path <- file.path(aedir, i - 1L)
            tryCatch({ 
                altSaveObject(altExp(x, alt.nms[i], withDimnames=FALSE), alt.path, ...)
            }, error =function(e) {
                stop("failed to stage 'altExp(<", class(x)[1], ">, \"", alt.nms[i], "\")'\n  - ", e$message)
            })
        }
        write(toJSON(alt.nms), file=file.path(aedir, "names.json"))
    }

    info <- list(version="1.0")
    main.nm <- mainExpName(x)
    if (!is.null(main.nm)) {
        info$main_experiment_name <- main.nm
    }

    meta <- readObjectFile(path)
    meta$single_cell_experiment <- info
    saveObjectFile(path, "single_cell_experiment", meta)

    invisible(NULL)
})

##################################
######### OLD STUFF HERE #########
##################################

#' @export
setMethod("stageObject", "SingleCellExperiment", function(x, dir, path, child=FALSE, rd.name="dimreds", ...) {
    meta <- callNextMethod()
    sce.details <- list()
    names(sce.details) <- character(0)

    # Staging the reduced dimensions.
    red.nms <- reducedDimNames(x)
    if (length(red.nms)) {
        if (anyDuplicated(red.nms)) {
            stop("detected duplicate names for reduced dimensions in a ", class(x)[1], " object")
        }
        if (any(red.nms == "")) {
            stop("detected empty names for reduced dimensions in a ", class(x)[1], " object")
        }

        entries <- vector('list', length(red.nms))
        for (i in seq_along(red.nms)) {
            red.path <- file.path(path, paste0("reddim-", i))

            red.processed <- tryCatch({
                rd.meta <- .stageObject(reducedDim(x, red.nms[i]), dir, red.path, child=TRUE)
                .writeMetadata(dir=dir, rd.meta)
            }, error=function(e) {
                stop("failed to stage 'reducedDim(<", class(x)[1], ">, \"", red.nms[i], "\")'\n  - ", e$message)
            })

            entries[[i]] <- list(name = red.nms[i], resource = red.processed)
        }

        sce.details$reduced_dimensions <- entries
    }

    # Staging the alternative experiments.
    alt.nms <- altExpNames(x) 
    if (length(alt.nms)) {
        if (anyDuplicated(alt.nms)) {
            stop("detected duplicate names for alternative experiments in a ", class(x)[1], " object")
        }
        if (any(alt.nms == "")) {
            stop("detected empty names for alternative experiments in a ", class(x)[1], " object")
        }

        entries <- vector("list", length(alt.nms))
        for (i in seq_along(alt.nms)) {
            alt.path <- file.path(path, paste0("altexp-", i))

            alt.processed <- tryCatch({ 
                alt.meta <- .stageObject(altExp(x, alt.nms[i]), dir=dir, path = alt.path, child=TRUE)
                .writeMetadata(meta=alt.meta, dir=dir)
            }, error =function(e) {
                stop("failed to stage 'altExp(<", class(x)[1], ">, \"", alt.nms[i], "\")'\n  - ", e$message)
            })

            entries[[i]] <- list(name = alt.nms[i], resource = alt.processed)
        }

        sce.details$alternative_experiments <- entries
    }

    main.nm <- mainExpName(x)
    if (!is.null(main.nm)) {
        if (any(alt.nms == main.nm)) {
            stop("conflicting name '", main.nm, "' for main and alternative experiments in a ", class(x)[1], " object")
        }
        sce.details$main_experiment_name <- main.nm
    }

    meta$single_cell_experiment <- sce.details
    meta[["$schema"]] <- "single_cell_experiment/v1.json"

    meta
})

## ----echo=FALSE---------------------------------------------------------------
library(BiocStyle)
self <- Biocpkg("alabaster.sce")
knitr::opts_chunk$set(error=FALSE, warning=FALSE, message=FALSE)

## -----------------------------------------------------------------------------
library(SingleCellExperiment)
mat <- matrix(rpois(10000, 10), ncol=10)
colnames(mat) <- letters[1:10]
rownames(mat) <- sprintf("GENE_%i", seq_len(nrow(mat)))

sce <- SingleCellExperiment(list(counts=mat))
sce$stuff <- LETTERS[1:10]
sce$blah <- runif(10)
reducedDims(sce) <- list(
 PCA=matrix(rnorm(ncol(sce)*10), ncol=10),
 TSNE=matrix(rnorm(ncol(sce)*2), ncol=2)
)
altExps(sce) <- list(spikes=SummarizedExperiment(list(counts=mat[1:2,])))
sce

library(alabaster.sce)
tmp <- tempfile()
saveObject(sce, tmp)

list.files(tmp, recursive=TRUE)

## -----------------------------------------------------------------------------
roundtrip <- readObject(tmp)
class(roundtrip)

## -----------------------------------------------------------------------------
sessionInfo()

---
title: Saving `SingleCellExperiment`s to artifacts and back again
author:
- name: Aaron Lun
  email: infinite.monkeys.with.keyboards@gmail.com
package: alabaster.sce
date: "Revised: November 29, 2023"
output:
  BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{Saving and loading SingleCellExperiments}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, echo=FALSE}
library(BiocStyle)
self <- Biocpkg("alabaster.sce")
knitr::opts_chunk$set(error=FALSE, warning=FALSE, message=FALSE)
```

# Overview 

The `r self` package implements methods to save `SingleCellExperiment` objects to file artifacts and load them back into R.
Check out the `r Biocpkg("alabaster.base")` for more details on the motivation and concepts of the **alabaster** framework.

# Quick start

Given a `SingleCellExperiment`, we can use `saveObject()` to save it inside a staging directory:

```{r}
library(SingleCellExperiment)
mat <- matrix(rpois(10000, 10), ncol=10)
colnames(mat) <- letters[1:10]
rownames(mat) <- sprintf("GENE_%i", seq_len(nrow(mat)))

sce <- SingleCellExperiment(list(counts=mat))
sce$stuff <- LETTERS[1:10]
sce$blah <- runif(10)
reducedDims(sce) <- list(
 PCA=matrix(rnorm(ncol(sce)*10), ncol=10),
 TSNE=matrix(rnorm(ncol(sce)*2), ncol=2)
)
altExps(sce) <- list(spikes=SummarizedExperiment(list(counts=mat[1:2,])))
sce

library(alabaster.sce)
tmp <- tempfile()
saveObject(sce, tmp)

list.files(tmp, recursive=TRUE)
```

We can then load it back into the session with `loadObject()`.

```{r}
roundtrip <- readObject(tmp)
class(roundtrip)
```

# Session information {-}

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/saveSingleCellExperiment.R
\name{saveSingleCellExperiment}
\alias{saveSingleCellExperiment}
\alias{stageObject,SingleCellExperiment-method}
\alias{saveObject,SingleCellExperiment-method}
\title{Save a SingleCellExperiment to disk}
\usage{
\S4method{saveObject}{SingleCellExperiment}(x, path, ...)
}
\arguments{
\item{x}{A \linkS4class{SingleCellExperiment} object or one of its subclasses.}

\item{path}{String containing the path to a directory in which to save \code{x}.}

\item{...}{Further arguments to pass to the RangedSummarizedExperiment method.}
}
\value{
\code{x} is saved into \code{path} and \code{NULL} is invisibly returned.
}
\description{
Save a \linkS4class{SingleCellExperiment} to its on-disk representation.
}
\examples{
# Mocking up an SCE:
mat <- matrix(rpois(10000, 10), ncol=10)
colnames(mat) <- letters[1:10]
rownames(mat) <- sprintf("GENE_\%i", seq_len(nrow(mat)))

se <- SingleCellExperiment(list(counts=mat))
se$stuff <- LETTERS[1:10]
se$blah <- runif(10)
reducedDims(se) <- list(
    PCA=matrix(rnorm(ncol(se)*10), ncol=10),
    TSNE=matrix(rnorm(ncol(se)*2), ncol=2)
)
altExps(se) <- list(spikes=SummarizedExperiment(list(counts=mat[1:2,])))

# Staging it: 
tmp <- tempfile()
saveObject(se, tmp)
list.files(tmp, recursive=TRUE)

}
\seealso{
\code{\link{readSingleCellExperiment}}, to read the SingleCellExperiment back into the R session.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readSingleCellExperiment.R
\name{readSingleCellExperiment}
\alias{readSingleCellExperiment}
\alias{loadSingleCellExperiment}
\title{Read a SingleCellExperiment from disk}
\usage{
readSingleCellExperiment(path, metadata, ...)
}
\arguments{
\item{path}{String containing a path to a directory, itself created using the \code{\link{saveObject}} method for \linkS4class{SingleCellExperiment} objects.}

\item{metadata}{Named list of metadata for this object, see \code{\link{readObjectFile}} for details.}

\item{...}{Further arguments passed to \code{\link{readRangedSummarizedExperiment}} and internal \code{\link{altReadObject}} calls.}
}
\value{
A \linkS4class{SingleCellExperiment} object.
}
\description{
Read a \linkS4class{SingleCellExperiment} object from its on-disk representation.
This is usually not directly called by users, but is instead called by dispatch in \code{\link{readObject}}.
}
\examples{
# Mocking up an SCE:
mat <- matrix(rpois(10000, 10), ncol=10)
colnames(mat) <- letters[1:10]
rownames(mat) <- sprintf("GENE_\%i", seq_len(nrow(mat)))

se <- SingleCellExperiment(list(counts=mat))
se$stuff <- LETTERS[1:10]
se$blah <- runif(10)
reducedDims(se) <- list(
    PCA=matrix(rnorm(ncol(se)*10), ncol=10),
    TSNE=matrix(rnorm(ncol(se)*2), ncol=2)
)
altExps(se) <- list(spikes=SummarizedExperiment(list(counts=mat[1:2,])))

# Staging it: 
tmp <- tempfile()
saveObject(se, tmp)
readObject(tmp)

}
\seealso{
\code{"\link{saveObject,SingleCellExperiment-method}"}, to save the SingleCellExperiment to disk.
}
\author{
Aaron Lun
}
